
// LinkSampleDlg.cpp : t@C
//

#include "stdafx.h"
#include "LinkSample.h"
#include "LinkSampleDlg.h"
#include "afxdialogex.h"
#include <string>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

typedef bool (*FuncReadData)( std::string );
typedef bool (*FuncReadDataAdd)( std::string );

typedef bool (*FuncWriteDataAll)( std::string );
typedef bool (*FuncWriteData)( int, std::string );

typedef bool (*FuncDeleteData)( int );
typedef bool (*FuncChangeData)( int, std::string );

typedef bool (*FuncReadDrawSetting)( std::string );
typedef bool (*FuncWriteDrawSetting)( std::string );

typedef bool (*FuncReadDataSetting)( int, std::string );
typedef bool (*FuncWriteDataSetting)( int, std::string );

typedef bool (*FuncWriteImage)( std::string );

typedef bool (*FuncGetNumberOfData)( int& );
typedef bool (*FuncGetDataName)( std::string& );
typedef bool (*FuncSetDataName)( std::string );


// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CLinkSampleDlg _CAO




CLinkSampleDlg::CLinkSampleDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CLinkSampleDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CLinkSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CLinkSampleDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_READ_DATA, &CLinkSampleDlg::OnBnClickedBtnReadData)
	ON_BN_CLICKED(IDC_BTN_READ_DATA_AND_WRITE_IMAGE, &CLinkSampleDlg::OnBnClickedBtnReadDataAndWriteImage)
	ON_BN_CLICKED(IDC_BTN_READ_DATA_AND_READ_DRAW_SETTING_AND_WRITE_IMAGE, &CLinkSampleDlg::OnBnClickedBtnReadDataAndReadDrawSettingAndWriteImage)
END_MESSAGE_MAP()


// CLinkSampleDlg bZ[W nh[

BOOL CLinkSampleDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// "o[W..." j[VXe j[ɒǉ܂B

	// IDM_ABOUTBOX ́AVXe R}h͈͓̔ɂȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

void CLinkSampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CLinkSampleDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CLinkSampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CLinkSampleDlg::OnBnClickedBtnReadData()
{
	HINSTANCE hLib;
	FuncReadData ReadData;

	if( ( hLib = LoadLibrary( L"GraphRPlusLink.dll" ) ) == NULL )
		return;

	if( ( ReadData = (FuncReadData)GetProcAddress( hLib, "ReadData" ) ) == NULL )
	{
		FreeLibrary( hLib );
		return;
	}

	std::string fname;
	fname = "sample003.csv";

	bool result = ReadData( fname );

	FreeLibrary( hLib );
}


void CLinkSampleDlg::OnBnClickedBtnReadDataAndWriteImage()
{
	HINSTANCE hLib;
	FuncReadData	ReadData;
	FuncWriteImage	WriteImage;

	if( ( hLib = LoadLibrary( L"GraphRPlusLink.dll" ) ) == NULL )
		return;

	if( ( ReadData = (FuncReadData)GetProcAddress( hLib, "ReadData" ) ) == NULL )
	{
		FreeLibrary( hLib );
		return;
	}

	if( ( WriteImage = (FuncWriteImage)GetProcAddress( hLib, "WriteImage" ) ) == NULL )
	{
		FreeLibrary( hLib );
		return;
	}

	std::string DataFileName, ImageFileName;
	bool result = false;

	DataFileName  = "sample003.csv";
	ImageFileName = "sample003.png"; 

	if( ReadData( DataFileName ) )
	{
		result = WriteImage( ImageFileName );
	}

	FreeLibrary( hLib );
}


void CLinkSampleDlg::OnBnClickedBtnReadDataAndReadDrawSettingAndWriteImage()
{
	HINSTANCE hLib;
	FuncReadData		ReadData;
	FuncWriteImage		WriteImage;
	FuncReadDrawSetting ReadDrawSetting;

	if( ( hLib = LoadLibrary( L"GraphRPlusLink.dll" ) ) == NULL )
		return;

	if( ( ReadData = (FuncReadData)GetProcAddress( hLib, "ReadData" ) ) == NULL )
	{
		FreeLibrary( hLib );
		return;
	}

	if( ( ReadDrawSetting = (FuncReadDrawSetting)GetProcAddress( hLib, "ReadDrawSetting" ) ) == NULL )
	{
		FreeLibrary( hLib );
		return;
	}

	if( ( WriteImage = (FuncWriteImage)GetProcAddress( hLib, "WriteImage" ) ) == NULL )
	{
		FreeLibrary( hLib );
		return;
	}

	std::string DataFileName, DrawSettingFileName, ImageFileName;
	bool result = false;

	DataFileName		= "sample003.csv";
	DrawSettingFileName = "DrawSetting.txt";
	ImageFileName		= "sample003.png"; 

	if( ReadData( DataFileName ) )
	{
		if( ReadDrawSetting( DrawSettingFileName ) )
		{
			result = WriteImage( ImageFileName );
		}
	}

	FreeLibrary( hLib );
}
